% vl_compilenn('enableGpu', true, ...
%                'cudaMethod', 'nvcc', ...
%                'cudaRoot', '/usr/local/cuda-7.5', ...
%                'enableCudnn', true, ...
%                'cudnnRoot', 'cudnn')
%%% SET UP DIRECTORIES AND FILENAMES
	clear global PARS

warning off MATLAB:dispatcher:nameConflict
warning off images:initSize:adjustingMag
global PARS

PARS.dir.DATAID  = 'VA';
PARS.dir.DIR     = '../../../data/Vaihingen_dataset/';
PARS.dir.DIRIMA  = '../../../data/Vaihingen_dataset/images/tiles/';
PARS.dir.DIRDSM  = '../../../data/Vaihingen_dataset/images/dsm/';
PARS.dir.DIRNDSM = '../../../data/Vaihingen_dataset/images/ndsm/';
PARS.dir.DIRGTS  = '../../../data/Vaihingen_dataset/images/gts/';

GTS = strsplit(sprintf('top_mosaic_09cm_area%i ',[1 3 5 7 11 13 15 17 21 23 26 28 30 32 34 37]),' ');
GTS = GTS(1:end-1); 
PARS.dir.GTS = GTS; clear GTS

trnind = [1 5 21 26 32 37];
valind = [3 7 13 17 23];
tstind = [11 15 28 30 34];

% IMTRAINALL = strsplit(sprintf('top_mosaic_09cm_area%i ',[1 3 5 7 11 13 17 26 28 32 34]),' ');
IMTRAINALL = strsplit(sprintf('top_mosaic_09cm_area%i ',[trnind valind]),' ');
IMTRAINALL = IMTRAINALL(1:end-1);
PARS.dir.IMTRAINALL = IMTRAINALL; clear IMTRAINALL

IMTRAIN = strsplit(sprintf('top_mosaic_09cm_area%i ',trnind),' ');
IMTRAIN = IMTRAIN(1:end-1);
PARS.dir.IMTRAIN = IMTRAIN; clear IMTRAIN

IMVALID = strsplit(sprintf('top_mosaic_09cm_area%i ',valind),' ');
IMVALID = IMVALID(1:end-1);
PARS.dir.IMVALID = IMVALID; clear IMVALID

% IMTEST = strsplit(sprintf('top_mosaic_09cm_area%i ',[15 21 23 30 37]));
IMTEST = strsplit(sprintf('top_mosaic_09cm_area%i ',tstind));
IMTEST = IMTEST(1:end-1);
PARS.dir.IMTEST = IMTEST; clear IMTEST

IMTESTALL = strsplit(sprintf('top_mosaic_09cm_area%i ',[2 4 6 8 10 12 14 16 20 22 24 27 29 31 33 35 38]));
IMTESTALL = IMTESTALL(1:end-1);
PARS.dir.IMTESTALL = IMTESTALL; clear IMTESTALL

IMALL = strsplit(sprintf('top_mosaic_09cm_area%i ',[1:8 10:17 20:24 26:35 37 38]));
IMALL = IMALL(1:end-1);
PARS.dir.IMALL = IMALL; clear IMALL

DSMTRAIN = strsplit(sprintf('dsm_09cm_matching_area%i ',[trnind valind]),' ');
DSMTRAIN = DSMTRAIN(1:end-1);
PARS.dir.DSMTRAIN = DSMTRAIN; clear DSMTRAIN

DSMTEST = strsplit(sprintf('dsm_09cm_matching_area%i ',[tstind]));
DSMTEST = DSMTEST(1:end-1);
PARS.dir.DSMTEST = DSMTEST; clear DSMTEST

DSMTESTALL = strsplit(sprintf('dsm_09cm_matching_area%i ',[2 4 6 8 10 12 14 16 20 22 24 27 29 31 33 35 38]));
DSMTESTALL = DSMTESTALL(1:end-1);
PARS.dir.DSMTESTALL = DSMTESTALL; clear DSMTESTALL

DSMALL = strsplit(sprintf('dsm_09cm_matching_area%i ',[1:8 10:17 20:24 26:35 37 38]));
DSMALL = DSMALL(1:end-1);
PARS.dir.DSMALL = DSMALL; clear DSMALL

PARS.dir.desccolor    = 'data/Vaihingen_dataset/descriptors/color/';
PARS.dir.desclocation = 'data/Vaihingen_dataset/descriptors/location/';
PARS.dir.descbow      = 'data/Vaihingen_dataset/descriptors/texture/';

%%% Superpixeling : % Felzenswalb : roughly best parameters 
% PARS.sp.method    = 'sticky';
% PARS.sp.fast      = 0;
% PARS.sp.bands     = [1 2 3];
% PARS.sp.opts = spDetect;
% PARS.sp.opts.type = 'sticky';
% PARS.sp.opts.nThreads = 4;  % number of computation threads
% PARS.sp.opts.k      = 1024;       % controls scale of superpixels (big k -> big sp)
% PARS.sp.opts.alpha  = 0.5;    % relative importance of regularity versus data terms
% PARS.sp.opts.beta   = 0.9;     % relative importance of edge versus color terms
% PARS.sp.opts.merge  = 0;     % set to small value to merge nearby superpixels at end
% PARS.sp.opts.nIter  = [100];
% PARS.sp.opts.bounds = 0;

% PARS.sp.method    = 'felzen';
% PARS.sp.smooth    = 0;
% PARS.sp.threshold = 50;
% PARS.sp.minsize   = 50;
% PARS.sp.bands     = [1 2 3 4];

% General params of the system
PARS.in.ncores         = 8; % parallel computing toolbox required
PARS.in.nclass         = 6;
PARS.in.bands          = [1 2 3]; % on which channels compute stuff ()
% PARS.in.normtype       = 'zscores';
PARS.in.normtype       = 'zeroone';
PARS.in.recomputecentr = false; % recompute visual words
PARS.in.VERBOSE        = true;
% PARS.in.distconn       = 250;
PARS.in.dsmnorm        = 'absolute'; % absolute
PARS.in.measureopt     = 'aa';
PARS.in.resolution     = 0.09; %m/px
% Random Forest configuration
PARS.rf.copeunbalanced   = 'subsample'; % 'subsample','weight'
% PARS.rf.fractrnperclass  = [0.5 0.3 500 500 1500 1 200 1 1]; % Roads Builds Trees Grass Comm BareS Water Rails Pools
PARS.rf.fractrnperclass  = [1 1 1 1 1 1]; % ONLY IF PARS.rf.copeunbalanced = 'subsample'; 

PARS.rf.nTrees           = 100;
PARS.rf.numTrials        = []; % selected as sqrt(dim)
PARS.rf.SplitTrain       = @RFSplitSingleFeatBestEntropyRemoveZeros;%@RFSplitSingleFeatBestEntropy; 
PARS.rf.AssignFunc       = @RFAssignSingleFeatTree;
PARS.rf.StopTrain        = @RFStopSingleClass;%@RFStopMaxDepth @RFStopSingleClass
PARS.rf.bagFraction      = 1;
PARS.rf.debug            = 0;
PARS.rf.maxDepth         = 15;
PARS.rf.doRandBetweenValues = 0;

% CRF
% PW1 = 1;
% PW2 = 1;
% PW3 = 1;
PARS.crf.inference  = 'qpbo';   % 'gcmex','qpbo'
% PARS.crf.QPBOmethod = int32(1); % 1 for QPBO-I to relabel unlabelled
% PARS.crf.QPBOPiters = 100;      % Contraction iteration of QPBO-P
% PARS.crf.QPBOIntern = 0;        % use larger intergers (less saturation)
PARS.crf.background = false; 
PARS.crf.biasCV     = 0;%0:0.5:2; % bias pairwise term qpbo never wants a diff from 0 (?!)
PARS.crf.weightCV1  = [0.1 1.5];%0.1 1.5]; % pairwise 1 - unary weight % |||| PROVIDE [MIN MAX], linspace between the two
PARS.crf.weightCV2  = [0.5 1.5];%0.5 1.5];%[0.5 1.5]; % pairwise 2 - unary weight % |||| PROVIDE [MIN MAX], linspace between the two
PARS.crf.edgedescr  = {'ColorHistogram'}; % 'MeanStd','ColorHistogram' % for contrast sensitive Potts
PARS.crf.contrastsensitvedistance = 'oneminussim'; % 'oneminussim','boundaryregularizer','exponential','oneoverdist' 
PARS.crf.energymodel = {'contrast', 'cooccurrence','contrast+cooccurrence'};
PARS.crf.cooccurrencetype = {'localcooccurrence','relativelocationprior'}; % 'relativelocationprior'  'localcooccurrence'; % 
PARS.crf.acctoopt   = 'aa';

% Descriptors
PARS.desc.blocks{1}  = {'spectral','location','textons','color','location-texton',...
    'location-color','texton-color','wholeset','whole-nodilated','whole-onlydilated'};%;,'specialset'};
PARS.desc.blocks{2}  = {'MeanStd','Depth'};
PARS.desc.blocks{3}  = {'localSPmask' 'relativeSParea' 'relativeBBsize' 'GIST'}; %  
PARS.desc.blocks{4}  = {'TextonHistogram','TextonHistogramDilated','SIFTHistogram','SIFTHistogramDilated', ...
'HOGHistogram', 'HOGHistogramDilated'};% 'LBPHistogram' 'LBPHistogramDilated' 
PARS.desc.blocks{5}  = {'ColorHistogram', 'MeanStd', 'ColorThumb', 'Depth', 'nDepth'}; % ColorThumbSP
PARS.desc.blocks{6}  = {PARS.desc.blocks{3}{:} PARS.desc.blocks{4}{:}};
PARS.desc.blocks{7}  = {PARS.desc.blocks{3}{:} PARS.desc.blocks{5}{:}};
PARS.desc.blocks{8}  = {PARS.desc.blocks{4}{:} PARS.desc.blocks{5}{:}};
PARS.desc.blocks{9}  = {PARS.desc.blocks{3}{:} PARS.desc.blocks{4}{:} PARS.desc.blocks{5}{:}};
PARS.desc.blocks{10} = {'TextonHistogram' 'SIFTHistogram' 'HOGHistogram' PARS.desc.blocks{5}{:}};
% PARS.desc.blocks{10} = {PARS.desc.blocks{3}{:} 'TextonHistogram' 'SIFTHistogram' 'LBPHistogram' 'HOGHistogram' PARS.desc.blocks{5}{:}};
PARS.desc.blocks{11} = {PARS.desc.blocks{3}{:} 'TextonHistogramDilated' 'SIFTHistogramDilated' 'LBPHistogramDilated' 'HOGHistogramDilated' PARS.desc.blocks{5}{:}};

% PARS.desc.types   = {                % dimensions with standard settings
% PARS.desc.type = {
%%%% LOCATION
%     'localSPmask';              % 64
%     'relativeBBsize';           % 2
%     'relativeSParea';           % 1
%     'globalSPmask';             % 64
%     'averageBBcoordinate';      % 2
%     'GIST';                     % 32  (8+8+8+8)
%%%% TEXTONS - TEXTURE
%     'TextonHistogram';          % # words
%     'TextonHistogramDilated';   % # words % careful with oversmoothing!
%     'SIFTHistogram';            % # words 
%     'SIFTHistogramDilated';     % # words % careful with oversmoothing! 
% %     'LBPHistogram';             % # words
% %     'LBPHistogramDilated';      % # words % careful with oversmoothing!
%     'HOGHistogram';             % # words
%     'HOGHistogramDilated';      % # words % careful with oversmoothing!
% %     'STF';                      % Tree depth * PARS.in.nclass
%     % %%%%% COLOR
%     'ColorHistogram';           % bins * CHANNELS
%     'MeanStd';                  % 4    * 2 + 2 (NDVI ME / STD INCLUDED)
%     'ColorThumb';               % 256 (8x8x4)
%     'ColorThumbSP';             % 256 (8x8x4) % Messes things up, better not using
%%%%%%% DEPTH
% 'Depth';
% 'nDepth'
%     };
%   -----------------------------------               
% PARS.desc.num = length(PARS.desc.type);

% 'localSPmask', 'glbalSPmask', 'ColorThumbnails'
PARS.thumb.size  = [10 10];

% 'TextonHistogram
PARS.text.fullMaxResp8   = false; % true: use full MR8 (32 dims), otherwise reduced MR8 (8 dims)
PARS.text.dictionarySize = 1000;
PARS.text.nSampPerImage  = 20000;
PARS.text.dilation       = 1; % to compute dilated histogram 
PARS.text.kmeansiters    = 750;
PARS.text.bands          = [1 2 3];
% PARS.text.method         = 'lloyd'; % | 'elkan'

% 'SIFTHistogram'
PARS.sift.dictionarySize = PARS.text.dictionarySize;
PARS.sift.nSampPerImage  = PARS.text.nSampPerImage;
PARS.sift.BlockSize      = 4; 
PARS.sift.BlockNum       = 4;
PARS.sift.Sigma          = 5;
PARS.sift.ColourNorm     = 'false';
PARS.sift.dilation       = PARS.text.dilation; % to compute dilated histogram 
PARS.sift.doPCA          = false;
PARS.sift.dimPCA         = 25;
PARS.sift.bands          = [1 2 3];
PARS.sift.kmeansiters    = PARS.text.kmeansiters;

% 'LBPHistogram' % OBSOLETE. NOW IS PER IMAGE INDEPENDENTLY
PARS.lbp.dictionarySize = PARS.text.dictionarySize;
PARS.lbp.nSampPerImage  = PARS.text.nSampPerImage;
PARS.lbp.kmeansiters    = PARS.text.kmeansiters;
PARS.lbp.visualwordtra  = true;
PARS.lbp.dilation       = PARS.text.dilation; % to compute dilated histogram 
PARS.lbp.presmoothpar   = 1; % 0 = no smoothing (No Gaussian smoothing)
PARS.lbp.bands          = PARS.text.bands;

%  'HOGHistogram'
PARS.hog.dictionarySize = PARS.text.dictionarySize;
PARS.hog.Sigma          = 5;%PARS.sift.Sigma;
PARS.hog.nSampPerImage  = PARS.text.nSampPerImage;
PARS.hog.dilation       = PARS.text.dilation; % to compute dilated histogram 
PARS.hog.kmeansiters    = PARS.text.kmeansiters;
PARS.hog.bands          = PARS.text.bands;

% 'GIST'
PARS.gist.orientationsPerScale = [8 8 8 8];
PARS.gist.numberBlocks         = [1]; % one per rect. SP mask
PARS.gist.fc_prefilt           = 5;
PARS.gist.bands                = [1 2 3];

% 'ColorHistogram'
PARS.colhist.bins       = 27;

    % Colormap
    PARS.in.legend = [255 255 255;   % 1  Impervious surfaces
              0 0 255;       % 2  Buildings 
              0 255 255;     % 3  Low vegetation
              0 255 0;       % 4  Tree 
              255 255 0;     % 5  Car
              255 0 0;       % 6  Clutter / background
             ]./255; 

PARS.in.Labels = {'Impervious_surfaces','Buildings','Low_vegetation','Tree','Car','Clutter_background'};

%%% EMAIL SETUP

% Modify these two lines to reflect
% your account and password.
% myaddress = 'michele.volpi@ed.ac.uk';
% mypassword = 'mypassword';

setpref('Internet','E_mail','michele.volpi@geo.uzh.ch');
setpref('Internet','SMTP_Server','smtp.geo.uzh.ch');
setpref('Internet','SMTP_Username','mvolpi');
setpref('Internet','SMTP_Password','Mitch85_');

props = java.lang.System.getProperties;
props.setProperty('mail.smtp.auth','true');
props.setProperty('mail.smtp.socketFactory.class', ...
                  'javax.net.ssl.SSLSocketFactory');
props.setProperty('mail.smtp.socketFactory.port','465');
props.setProperty('mail.smtp.port','465');


% % 
% % 
% 
% vl_compilenn('enableGpu', true, ...
%                'cudaMethod', 'nvcc', ...
%                'cudaRoot', '/usr/local/cuda-7.5', ...
%                'enableCudnn', true, ...
%                'cudnnRoot', '/usr/local/cuda-7.5') ;
