% opts_. will contain (after setupPotsdam) 

%            gtDir: {1x24 cell} -> all Potsdam GTs
%     trnvalImages: {1x24 cell} -> mixed train and validation images
%        valImages: {1x6 cell}  -> only validation images 
%        trnImages: {1x18 cell} -> only training images
%        allImages: {1x38 cell} -> all training images
%         tstImags: {1x14 cell} -> only test (GT not available) images
%          allNdsm: {1x38 cell} -> all training ndsm
%       trnvalNdsm: {1x24 cell} -> mixed train and validation images
%          valNdsm: {1x6 cell}  -> only validation images 
%          trnNdsm: {1x18 cell} -> only training images
%          tstNdsm: {1x14 cell} -> only test (GT not available) images
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%% SET UP DIRECTORIES AND FILENAMES
warning off MATLAB:dispatcher:nameConflict
warning off images:initSize:adjustingMag

lis = dir(opts.gtDir); % 24 GTS
k = ~cellfun(@isempty,strfind({lis(:).name},'.tif'));
names = {lis(k).name};
opts_.gtDir = names;

% Test tiles are the ones containing _12 in the filename
testidx = ~cellfun(@isempty,strfind(names,'_12')); trainidx = ~testidx;
opts_.gtValid = opts_.gtDir(testidx);
opts_.gtTrain = opts_.gtDir(trainidx);

lis = dir(opts.imageDir); % 38 PATCHES
k = ~cellfun(@isempty,strfind({lis(:).name},'.tif'));
opts_.allImages = {lis(k).name}; 

names = cellfun(@(x) x(1:end-10),opts_.gtDir,'UniformOutput',false);
ims   = repmat({'%s_RGBIR.tif'},1,size(names,2));
opts_.trnvalImages  = cellfun(@sprintf,ims,names,'UniformOutput',false);

opts_.valImages = opts_.trnvalImages(testidx); 
opts_.trnImages = opts_.trnvalImages(trainidx);  

opts_.tstImags = opts_.allImages;
for i = 1:length(opts_.trnvalImages)
    opts_.tstImags  = opts_.tstImags(~strcmp(opts_.tstImags,opts_.trnvalImages{i}));
end

lis = dir(opts.ndsmDir); % 38 PATCHES
k = ~cellfun(@isempty,strfind({lis(:).name},'ownapproach.jpg'));
opts_.allNdsm = {lis(k).name}; 

NAMES_ = cellfun(@(x) ['dsm' x(4:end)],opts_.gtDir,'UniformOutput',false);
NAMES_ = cellfun(@(x) [x(1:12) '0' x(13:end-10)],NAMES_,'UniformOutput',false);
for ii = 1:length(NAMES_)
    if length(NAMES_{ii}) == 16
         NAMES_{ii} = [NAMES_{ii}(1:15) '0' NAMES_{ii}(16:end)];
    end
end

ims   = repmat({'%s_normalized_ownapproach.jpg'},1,size(NAMES_,2));
opts_.trnvalNdsm = cellfun(@sprintf,ims,NAMES_,'UniformOutput',false);

opts_.valNdsm  = opts_.trnvalNdsm(testidx);
opts_.trnNdsm  = opts_.trnvalNdsm(trainidx);

opts_.tstNdsm = opts_.allNdsm;
for i = 1:length(opts_.trnvalNdsm)
    opts_.tstNdsm = opts_.tstNdsm(~strcmp(opts_.tstNdsm,opts_.trnvalNdsm{i}));
end

clear names ims lis testidx trainidx NAMES_
