% function [GTlab] = rgb2label(GT,legend)
% convert an RGB label image to indexes and vice versa
% indexes are in same order as appear in legend, provide legend in 0-1
% values (standard matlab cmap).
% _____________________________________________________
% Michele Volpi, CALVIN, University of Edinbrugh

function [GTlab] = rgb2label(GT,legend)

legend = legend.*255;

if size(GT,3) == 3
    GTlab = zeros(size(GT,1)*size(GT,2),1);
    GTc = data2column(GT);
    
    for i = 1:size(legend,1)
        GTlab(GTc(:,1) == legend(i,1) & GTc(:,2) == legend(i,2) & GTc(:,3) == legend(i,3)) = i;
    end
    GTlab = reshape(GTlab,size(GT,1),size(GT,2));
else
    GTlab = zeros(size(GT,1)*size(GT,2),3);
    GTc = data2column(GT);
    
    for i = 1:size(legend,1)
        GTlab(GTc == i,:) = repmat([legend(i,1) legend(i,2) legend(i,3)],sum(GTc == i),1);
    end
    GTlab = reshape(GTlab,size(GT,1),size(GT,2),3);
end
